<?php 
  include("cobalt.php");

  function totalSecs($length) {
      list($foo, $hour, $min, $sec) = explode(":", trim($length));
      return $hour*3600 + $min*60 + $sec;
  }

  function formatMinSec($min, $sec) {
      if(strlen($sec)<2) { $sec = "0".$sec; }
      return $min . ":" . $sec;
  }


  function timeThrough($percent, $totalSecs) {
      $tt = $totalSecs * $percent / 100;
      return "+".formatMinSec(floor($tt / 60), $tt % 60);
  }

  function timeRemaining($percent, $totalSecs) {
      $tr = $totalSecs * (100.0 - $percent) / 100;
      return "-".formatMinSec(floor($tr / 60), $tr % 60);
  }

  function whatsPlaying($channel) {
      global $cobalt;
      $base = "http://".$cobalt.":8000/";
      $pidfile="/var/ices/$channel/ices.pid";

      if(file_exists($pidfile)) {
          $ifp = fopen($pidfile,"r");
          $pid = fgets($ifp,4095);
          fclose($ifp);
          $cuefile="/var/ices/$channel/ices.cue.".$pid;
          if(file_exists($cuefile)) {
              $fp = fopen($cuefile, "r");
          } else {
              $excuse = "no cue file.";
          }
      } else {
          $excuse = "no pid file.";
      }

      if($fp) {
          $filename = fgets($fp, 4096);

          $basename = basename($filename);
          $toExplode = preg_replace("/\.mp3$/", "", $basename);
          $toExplode = preg_replace("/\.ogg$/", "", $toExplode);
          $toExplode = preg_replace("/[0-9a-fA-F]{5} % /", "", $toExplode);
          list($artist, $title) = explode(" - ", $toExplode);

          $size = fgets($fp, 40);
          $bitrate = fgets($fp, 40);
          $length = fgets($fp, 40);
           $totalsecs = totalSecs($length);
          $pctdone = trim(fgets($fp, 40));

          $remaining = timeRemaining($pctdone, $totalsecs);
          $through = timeThrough($pctdone, $totalsecs);

          $pctdone = floor($pctdone);
          if(strlen($pctdone)<2) { $pctdone = "0" . $pctdone; }
          $plindex = fgets($fp, 40);
          $artist2 = fgets($fp,1024);
          $title2 = fgets($fp,1024);
          fclose($fp);

          ?>
             <tr>
             <td width="24"><a href="m3us/<?php echo$channel?>.m3u"><img valign="center" src="/images/icons/xmms_mini.png" border=1 /></a></td>
             <td valign="center" align="left" colspan="3"><b><font size="+1"><?php echo $channel?></font></b></td>
             <td valign="center" align="right">
                 <a href="http://<?php echo $cobalt 
                 ?>/request-f2.phtml?genre=<?php echo $channel 
                 ?>&action=request"> request</a>

                 <a href="http://<?php echo $cobalt 
                 ?>/pld.phtml?genre=<?php echo $channel 
                 ?>&action=bump"> bump</a>

                 <a href="http://<?php echo $cobalt 
                 ?>/pld.phtml?genre=<?php echo $channel
                 ?>&action=kill"> kill</a>
             </td>
             </tr>
             <tr>
             <td></td>
             <td align="right">
                 <?php echo$artist?>
             </td>
             <td align="center" width="0%">
                 &nbsp;&nbsp;::&nbsp;&nbsp;
             </td>
             <td align="left">
                 <?php echo$title?>
             </td>
             <td colspan="1" align="left">
                 <?php echo$through?> / <?php echo$remaining?>
             </td>
             </tr>
          <?php
      } else {
           ?>
           <tr>
           <td colspan="4">
               <b><?php echo$channel?></b> sleeps (<?php echo$excuse ?>)
           </td>
           <td align="right">
           <a href="http://<?php echo $cobalt ?>/pld.phtml?genre=<?php
               echo $channel ?>&action=start">start</a>
           <a href="http://<?php echo $cobalt ?>/pld.phtml?genre=<?php 
               echo $channel ?>&action=kill">kill</a>
           </td>
           </tr>
           <?php
      }
  }
?>
